# OVM
OVM is a virtual machine for the Tree Language. You can find its
documentation in the [doc](https://gitlab.lre.epita.fr/tiger/ovm/-/tree/main/docs?ref_type=heads) directory.

# Usage
To run an hir program, you can do:
`dune exec ./bin/main.exe treetests/00.hir -- -show-ast`

the `-show-ast` option prints the produced AST before actually
evaluating the program.

## Options:
  - `-show-ast` Enables the printing of the AST
  - `-heap-size` Set the heap size
  - `-stack-size` Set the stack size
  - `-trace` Prints the intermediate execution steps
  - `-lin` Linearizes the program before evalution
  - `-lir` Check if the program is low-level
  - `-unsafe` Don't do the static checks
  - `-32` Evaluate the program using 32 bit semantics (default)
  - `-64` Evaluate the program using 64 bit semantics
  - `-help`  Displays the list of options
  - `--help`  Displays the list of options

# tests
`make test` should run the evaluator on the files in the `treetests/` directory  
and compare their results against the specified values

# Code overview
- treetests/ directory contains some .hir files
- lib/ directory contains all modules of the ovm library
- bin/ contains the actual OVM executable
- tests/ contains the code for the tests

# Acknowledgements
OVM has been written, and is maintained, by Damien Assire, Mael
Cravero and Ghiles Ziat. Its developpement has been generously
supported by [IRILL](https://www.irill.org/)
