open Tree

exception LexingError of string
(** raised during lexing when input is invalid *)

exception ParsingError of string
(** raised during parsing when input is invalid *)

exception IllFormed of string
(** raised during static checks *)

exception RuntimeError of string * Memory.t
(** raised at runtime when some invalid operation is executed *)

exception JumpException of label * location * Memory.t
exception ExitException of int * Memory.t

let ill_formed msg location =
  raise
    (IllFormed
       (Format.asprintf "Ill-formed program, \"%s\" in %a\n" msg Errors.from_loc
          location))

let runtime_error msg location mem =
  raise
    (RuntimeError
       (Format.asprintf "\"%s\" in %a\n" msg Errors.from_loc location, mem))
