open Exceptions
open Result

let print_int =
  Function.unary
    (fun mem x ->
      Vmio.printf "%d%!" x;
      (mem, Nothing))
    "print_int"

let print =
  Function.unary
    (fun mem x ->
      let str =
        try Memory.fetch_str mem x
        with Failure msg ->
          raise (RuntimeError (Format.sprintf "print : %s" msg, mem))
      in
      Vmio.printf "%s%!" str;
      (mem, Nothing))
    "print"

let print_err =
  Function.unary
    (fun mem x ->
      let str =
        try Memory.fetch_str mem x
        with Failure msg ->
          raise (RuntimeError (Format.sprintf "print_err : %s" msg, mem))
      in
      Vmio.printf "%s%!" str;
      (mem, Nothing))
    "print_err"
