let test = ref false
let show_ast = ref false
let trace = ref false

(* TODO : argv *)
let jump_debug = ref false
let linearize = ref false
let lir_check = ref false
let unsafe = ref false
let heapsize = ref 65536
let stacksize = ref 16384
let file = ref ""
let word_size = ref 32

module SSet = Set.Make (String)
module SMap = Map.Make (String)

let print_smap ?pp_sep pp_elem fmt smap =
  let print_pair fmt (s, v) = Format.fprintf fmt "%s:%a" s pp_elem v in
  Format.fprintf fmt "%a"
    (Format.pp_print_list ?pp_sep print_pair)
    (SMap.bindings smap)

let print_sset fmt ~pp_sep sset =
  Format.fprintf fmt "%a"
    (Format.pp_print_list ~pp_sep Format.pp_print_string)
    (List.of_seq (SSet.to_seq sset))

(** div_ceiling
 *  Return the smallest integer greater than or equal to n/d
 *)
let div_ceiling (n : int) (d : int) : int = ((n - 1) / d) + 1

module type Arith = sig
  type t

  (* conversion *)
  val of_int : int -> t
  val to_int : t -> int
  val of_string : string -> t

  (* comparisons *)
  val compare : t -> t -> int
  val unsigned_compare : t -> t -> int

  (* arithmetics *)
  val add : t -> t -> t
  val sub : t -> t -> t
  val mul : t -> t -> t
  val div : t -> t -> t
  val rem : t -> t -> t

  (* logic *)
  val logand : t -> t -> t
  val logor : t -> t -> t
  val logxor : t -> t -> t
  val shift_left : t -> int -> t
  val shift_right_logical : t -> int -> t
  val shift_right : t -> int -> t
end
